unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, MMSystem;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
  public
  end;

var
  Form1: TForm1;
  Som1: pointer;

implementation
{$R *.DFM}

//=== Carrega um arquivo wav para a memria ====================================
function AbrirSom(Arq: string): pointer;
var
  Str: TFileStream;
begin
  Str:= TFileStream.create(Arq,
               fmOpenRead or fmShareDenyNone);
  Str.position:= 0;
  GetMem(result, Str.size); //pega a memria
  Str.Read(result^, Str.size);
  Str.free;
end;


//=== Tocar um som na memria ==================================================
procedure TocarSom(Som: pointer;
  Loop: boolean = false; Async: boolean = true);
var
  Ops: cardinal;
begin
  Ops:= SND_MEMORY;
  if Loop then Ops:= Ops + SND_LOOP;
  if Async then Ops:= Ops + SND_ASYNC;
  PlaySound(Som, 0, Ops);
end;


//=== Interromper o som ========================================================
procedure PararSom;
begin
  PlaySound(nil, 0, SND_PURGE);
end;


//=== Remover som da memria ===================================================
procedure FecharSom(var Som: pointer);
begin
  if Som <> nil then FreeMem(Som);
  Som:= nil;
end;


////////////////////////////////////////////////////////////////////////////////
procedure TForm1.FormCreate(Sender: TObject);
begin
  Som1:= AbrirSom('teste.wav');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FecharSom(Som1);
end;

procedure TForm1.FormMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  TocarSom(Som1, true, true);
end;

procedure TForm1.FormMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  PararSom;
end;

end.
